﻿using Syncfusion.XForms.ProgressBar;
using System;
using System.ComponentModel;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace DownloadingSample
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(false)]
    public partial class MainPage : ContentPage
    {
        private bool flag;

        private int duration = 10000;

        public MainPage()
        {
            InitializeComponent();
        }

        private void ProgressBarBase_OnValueChanged(object sender, ProgressValueEventArgs e)
        {
            if (e.Progress > 0 && e.Progress <= 20)
            {
                this.step1.FontAttributes = FontAttributes.Bold;
            }
            else if (e.Progress > 20 && e.Progress <= 40)
            {
                this.step1.FontAttributes = FontAttributes.None;
                this.step2.FontAttributes = FontAttributes.Bold;
            }
            else if (e.Progress > 40 && e.Progress <= 60)
            {
                this.step2.FontAttributes = FontAttributes.None;
                this.step3.FontAttributes = FontAttributes.Bold;
            }
            else if (e.Progress > 60 && e.Progress <= 80)
            {
                this.step3.FontAttributes = FontAttributes.None;
                this.step4.FontAttributes = FontAttributes.Bold;
            }
            else if (e.Progress > 80 && e.Progress <= 100)
            {
                this.step4.FontAttributes = FontAttributes.None;
                this.step5.FontAttributes = FontAttributes.Bold;
            }
            else
            {
                this.step5.FontAttributes = FontAttributes.None;
            }
        }

        private async void DownloadMethod(object sender, EventArgs e)
        {
            this.Next.IsEnabled = false;
            this.Cancel.IsEnabled = true;
            this.flag = this.LinearProgressBar.Progress < 100;
            this.LinearProgressBar.ProgressColor = Color.FromRgba(0, 120, 214, 255);
            while (this.flag)
            {
                double progress = this.LinearProgressBar.Progress % 20;
                ////progress - Enter the progress percentage value from the downloading API.
                this.LinearProgressBar.Progress += (20 - progress);
                this.flag = this.LinearProgressBar.Progress < 100;
                await Task.Delay(this.duration);
            }
        }

        private async void LinearProgressBar_OnProgressCompleted(object sender, ProgressValueEventArgs e)
        {
            await Task.Delay(this.duration);
            this.LinearProgressBar.ProgressColor = Color.Green;
            this.Next.IsEnabled = false;
            this.Cancel.IsEnabled = false;
        }

        private void Cancel_OnClicked(object sender, EventArgs e)
        {
            this.LinearProgressBar.Progress =
                (double)this.LinearProgressBar.GetValue(SfLinearProgressBar.ActualProgressValueProperty);
            this.flag = false;
            this.Next.Text = "Continue";
            this.Next.IsEnabled = true;
            this.LinearProgressBar.ProgressColor = Color.Crimson;
        }
    }
}
